

<?php 
/**

  The Initial Developer of the Original Code is
  Matthieu  - http://www.programmation-facile.com/
  Portions created by the Initial Developer are Copyright (C) 2013
  the Initial Developer. All Rights Reserved.

  Contributor(s) :

 */


/** 
 * Ce fichier contient plusieurs classes
 * montre l'utilisation du modèle de conception Fabrique
 * 
 */


/**
 * Classe abstraite d'un produit
 *
 * Tous les classes produits créées contiennent ces méthodes et propriétés
 */
abstract class Product 
{
	private $nReference;// référence du produit
	private $sNomModele;// le modèle du produit
	protected $sType = null;// le type de produit


	public function __construct($nRef, $sNModel)
	{
		$this->nReference = $nRef;
		$this->sNomModele = $sNModel;
	}


	/**
	 * Renvoie la référence du produit
	 * 
	 * @return [type] [description]
	 */
	public function getReference()
	{
		return $this->nReference;
	}


	/**
	 * Renvoie le modèle du produit
	 * 
	 * @return [type] [description]
	 */
	public function getModele()
	{
		return $this->sNomModele;
	}


	/**
	 * Renvoie le type du produit
	 * 
	 * @return [type] [description]
	 */
	public function getType()
	{
		return $this->sType;
	}
}


/**
 * Les différents classes produits
 * s'appuient sur la classe abstraite
 * 
 */


class ProductChaise extends Product
{
	protected $sType = 'chaise';
}


class ProductTable extends Product
{
	protected $sType = 'table';
}


class ProductMeuble extends Product
{
	protected $sType = 'meuble';
}


class ProductSofa extends Product
{
	protected $sType = 'sofa';
}


?>